<template>
  <v-container>
    <v-form @submit.prevent="onSubmit">
      <div>
        <h1>กรอกข้อมูล</h1>
      </div>
      <!-- <div >
        <v-btn @click="dataAll">loadData
        </v-btn> :posts="loadData"
        
      </div> -->
      <div class="container map-margin">
        <MapComponent class="map-size" />
      </div>

      <div :posts="loadData"></div>

      <v-form>
        <label>
          <h2>สำนักงานทางหลวงที่:</h2>
          <v-col class="d-flex" cols="12" sm="6">
            <v-select
              v-model="formData.highway_office"
              :items="divisionList"
              label="สำนักงานทางหลวงที่"
              outlined
            ></v-select>
          </v-col>
        </label>
      </v-form>

      <v-form>
        <label>
          <h2>แขวงทางหลวง:</h2>
          <v-col class="d-flex" cols="12" sm="6">
            <v-select
              v-model="formData.district"
              :items="dis_nameList"
              label="แขวงทางหลวง"
              :filter="customFilter"
              :loading="loading"
              :search-input.sync="search"
              outlined
            ></v-select>
          </v-col>
        </label>
      </v-form>

      <v-form>
        <label>
          <h2>ทางแยก</h2>
          <label>
          <h3>ชื่อทางแยก:</h3>
            <v-text-field
              v-model="formData.crossroads"
              label="ชื่อทางแยก"
            ></v-text-field>
          </label>
        </label>
      </v-form>

      <v-form>
        <label>
          <h2>รายละเอียดถนนที่ตัดกัน</h2>
          <label>
            <h3>ถนนสายหลัก</h3>
            <v-container>
              <label>
                หมายเลขทางหลวง:
                <v-text-field
                  v-model="formData.main_highway_number"
                  label="หมายเลขทางหลวง"
                ></v-text-field>
              </label>
              <label>
                ชื่อทางหลวง:
                <v-text-field
                  v-model="formData.main_highway_name"
                  label="ชื่อทางหลวง"
                ></v-text-field>
              </label>
            </v-container>
          </label>
          <label>
            <h3>ถนนสายรอง</h3>
            <v-container>
              <label>
                หมายเลขทางหลวง:
                <v-text-field
                  v-model="formData.secondary_highway_number"
                  label="หมายเลขทางหลวง"
                ></v-text-field>
              </label>
              <label>
                ชื่อทางหลวง:
                <v-text-field
                  v-model="formData.secondary_highway_name"
                  label="ชื่อทางหลวง"
                ></v-text-field>
              </label>
            </v-container>
          </label>
        </label>
      </v-form>

      <v-form>
        <label>
          <h2>ภาพแผนผังทิศทางจราจรของ 4 แยก</h2>
          <!-- <v-container v-if="images">
              <v-img
                max-height="150"
                max-width="250"
                :src="images"
              ></v-img>
            </v-container> -->
            <!-- <img v-if="formData.imageUrl" :src="formData.imageUrl" /> -->
            <!-- {{ formData.imageUrl }} -->

          <!-- <div>{{ images }}
            <ul>

              <li v-for="image in images" :key="image.id">
                <img :src="image.url" />
              </li>
            </ul>
            
          </div>

          <form @submit.prevent="addImage">
            <input type="file" @change="handleFileUpload" />
            <button type="submit">Add Image</button>
          </form> -->
          
          <div class="ma-1">

            <!-- <v-img
            class="bg-white"
            width="300"
            :aspect-ratio="1"
            src={{ form.img4way }}
            ></v-img> -->
          
            <DropFile />
          </div>
          

          <!-- <v-file-input
            v-model="formData.imageUrl"
            label="File input"
            accept="image/png, image/jpeg, image/bmp"
            filled
            prepend-icon="mdi-camera"
            @click="showFilePreview"
            multiple
          ></v-file-input> -->
            
          <!-- <v-file-input type="image/png, image/jpeg, image/bmp" @change="uploadImage"/> -->
        
        </label>
      </v-form>

      <v-form>
        <h2>เสาไฟส่องสว่าง</h2>
          <!-- <v-radio-group v-model="formData.light_pole" v-if="formData.light_pole"> -->
            <!-- <v-radio-group v-model="formData.light_pole">
              <v-row class="pl-3">
                <v-col cols="auto">
                  <v-radio value="high_mast" label="High Mast" class="pt-2"></v-radio>
                </v-col>
                <v-col cols="auto" align="center">
                  <v-text-field v-model="formData.lightPole_HM" outlined dense :disabled="formData.light_pole !== 'high_mast'"></v-text-field>
                </v-col>
                <v-col cols="auto" class="d-flex align-items-center">
                  <label for="" class="mt-2 ">ม.</label>
                </v-col>
              </v-row>
              <v-row class="pl-3">
                <v-col cols="auto">
                  <v-radio value="single_pole_lamp" label="เสาไฟกิ่งเดี่ยว" class="pt-2"></v-radio>
                </v-col>
                <v-col cols="auto" align="center">
                  <v-text-field v-model="formData.lightPole_SP" outlined dense :disabled="formData.light_pole !== 'single_pole_lamp'"></v-text-field>
                </v-col>
                <v-col cols="auto" class="d-flex align-items-center">
                  <label for="" class="mt-2 ">ม.</label>
                </v-col>
              </v-row>
              <v-row class="pl-3">
                <v-col cols="auto">
                  <v-radio value="twin_lamp_post" label="เสาไฟกิ่งคู่" class="pt-2"></v-radio>
                </v-col>
                <v-col cols="auto" align="center">
                  <v-text-field v-model="formData.lightPole_TP" outlined dense :disabled="formData.light_pole !== 'twin_lamp_post'"></v-text-field>
                </v-col>
                <v-col cols="auto" class="d-flex align-items-center">
                  <label for="" class="mt-2 ">ม.</label>
                </v-col>
              </v-row>
            </v-radio-group> -->

            <v-radio-group v-model="formData.light_pole">
              <table>
                <tr>
                  <td><v-radio value="high_mast" label="High Mast" class="pb-5"></v-radio></td>
                  <td><v-text-field v-model="formData.lightPole_HM" outlined dense :disabled="formData.light_pole !== 'high_mast'"></v-text-field></td>
                  <td class="pb-6 pl-5">ม.</td>
                </tr>
                <tr>
                  <td><v-radio value="single_pole_lamp" label="เสาไฟกิ่งเดี่ยว" class="pb-5"></v-radio></td>
                  <td><v-text-field v-model="formData.lightPole_SP" outlined dense :disabled="formData.light_pole !== 'single_pole_lamp'"></v-text-field></td>
                  <td class="pb-6 pl-5">ม.</td>
                </tr>
                <tr>
                  <td><v-radio value="twin_lamp_post" label="เสาไฟกิ่งคู่" class="pb-5"></v-radio></td>
                  <td><v-text-field v-model="formData.lightPole_TP" outlined dense :disabled="formData.light_pole !== 'twin_lamp_post'"></v-text-field></td>
                  <td class="pb-6 pl-5">ม.</td>
                </tr>
              </table>
            </v-radio-group>

          <label for=""><h3>วันที่ซ่อมบำรุงล่าสุด</h3></label>
          <v-menu
            ref="menu"
            v-model="menu"
            :close-on-content-click="false"
            :return-value.sync="dates"
            transition="scale-transition"
            offset-y
            min-width="auto"
          >
            <template v-slot:activator="{ on, attrs }">
              <v-combobox
                v-model="formData.lightPole_MD"
                chips
                small-chips
                label="วันที่สิ้นสุดการรับประกัน"
                prepend-icon="mdi-calendar"
                readonly
                v-bind="attrs"
                v-on="on"
              ></v-combobox>
            </template>
            <v-date-picker
              v-model="formData.lightPole_MD"
              no-title
              scrollable
            >
            </v-date-picker>
          </v-menu>
          <label for=""><h3>วันที่สิ้นสุดการรับประกัน</h3></label>
          <v-menu
            ref="menu"
            v-model="menu"
            :close-on-content-click="false"
            :return-value.sync="dates"
            transition="scale-transition"
            offset-y
            min-width="auto"
          >
            <template v-slot:activator="{ on, attrs }">
              <v-combobox
                v-model="formData.lightPole_GD"
                chips
                small-chips
                label="วันที่สิ้นสุดการรับประกัน"
                prepend-icon="mdi-calendar"
                readonly
                v-bind="attrs"
                v-on="on"
              ></v-combobox>
            </template>
            <v-date-picker
              v-model="formData.lightPole_GD"
              no-title
              scrollable
            >
            </v-date-picker>
          </v-menu>
      </v-form>

      <div class="center-element">

        <SLPpart />
      </div>

      <v-form class="py-4">
        <label for=""><h2>ตู้ไฟสัญญาณ</h2></label>
        <v-container>
          <!-- {{ formData.adaptive }}{{ formData.adaptive_another }}{{ formData.adaptive_HTOC }}{{ formData.vehicleActuated }}{{ formData.vehicleActuated }} -->
          <label for=""><h3>ประเภทตู้ไฟสัญญาณ</h3></label>
          <v-radio-group v-model="formData.lightBox">
            <v-radio label="Adaptive" value="lightBox1"> </v-radio>
            <v-container v-if="formData.lightBox === 'lightBox1'">
              <v-radio-group v-model="formData.adaptive">
                <label for="xx">
                  <v-radio label="ขดลวดเหนี่ยวนำ (Inductive loop)" value="IL"></v-radio>
                  <v-radio label="ภาพวิดีโอ (Video Image processing)" value="VIP"></v-radio>
                  <v-row class="pl-0">
                    <v-col cols="auto">
                      <v-radio value="another" label="อื่น ๆ ระบุ" class="pt-2"></v-radio>
                    </v-col>
                    <v-col cols="auto" align="center">
                      <v-text-field v-model="formData.adaptive_another" outlined dense :disabled="formData.adaptive !== 'another'"></v-text-field>
                    </v-col>
                  </v-row>
                </label>
                <v-checkbox
                  v-model="formData.adaptive_HTOC"
                  :label="`มีการส่งข้อมูลการจราจรกลับไปที่ศูนย์ HTOC`"
                ></v-checkbox>
              </v-radio-group>
            </v-container>
            <v-radio label="Vehicle Actuated" value="lightBox2"></v-radio>
            <v-container v-if="formData.lightBox === 'lightBox2'">
              <v-radio-group v-model="formData.vehicleActuated">
                <label for="xx">
                  <v-radio label="ขดลวดเหนี่ยวนำ (Inductive loop)" value="IL"></v-radio>
                  <v-radio label="ภาพวิดีโอ (Video Image processing)" value="VIP"></v-radio>
                  <v-row class="pl-0">
                    <v-col cols="auto">
                      <v-radio value="another" label="อื่น ๆ ระบุ" class="pt-2"></v-radio>
                    </v-col>
                    <v-col cols="auto" align="center">
                      <v-text-field v-model="formData.vehicleActuated_another" outlined dense :disabled="formData.vehicleActuated !== 'another'"></v-text-field>
                    </v-col>
                  </v-row>
                </label>
                <v-checkbox
                  v-model="formData.vehicleActuated_HTOC"
                  :label="`มีการส่งข้อมูลการจราจรกลับไปที่ศูนย์ HTOC`"
                ></v-checkbox>
              </v-radio-group>
            </v-container>
            <v-radio label="Fixed time" value="lightBox3"> </v-radio>
          </v-radio-group>

          <label for=""><h3>วันที่ซ่อมบำรุงล่าสุด</h3></label>
          <v-menu
            ref="menu"
            v-model="menu"
            :close-on-content-click="false"
            :return-value.sync="dates"
            transition="scale-transition"
            offset-y
            min-width="auto"
          >
            <template v-slot:activator="{ on, attrs }">
              <v-combobox
                v-model="formData.lightBox_MD"
                chips
                small-chips
                label="วันที่สิ้นสุดการรับประกัน"
                prepend-icon="mdi-calendar"
                readonly
                v-bind="attrs"
                v-on="on"
              ></v-combobox>
            </template>
            <v-date-picker
              v-model="formData.lightBox_MD"
              no-title
              scrollable
            >
            </v-date-picker>
          </v-menu>
          <label for=""><h3>วันที่สิ้นสุดการรับประกัน</h3></label>
          <v-menu
            ref="menu"
            v-model="menu"
            :close-on-content-click="false"
            :return-value.sync="dates"
            transition="scale-transition"
            offset-y
            min-width="auto"
          >
            <template v-slot:activator="{ on, attrs }">
              <v-combobox
                v-model="formData.lightBox_GD"
                chips
                small-chips
                label="วันที่สิ้นสุดการรับประกัน"
                prepend-icon="mdi-calendar"
                readonly
                v-bind="attrs"
                v-on="on"
              ></v-combobox>
            </template>
            <v-date-picker
              v-model="formData.lightBox_GD"
              no-title
              scrollable
            >
            </v-date-picker>
          </v-menu>
        </v-container>
      </v-form>

      <v-radio-group v-model="formData.roadType">
        <label for=""><h2>ประเภทผิวจราจรเขตทางแยก</h2></label>
        <v-radio label="แอสฟัลต์" value="Asphalt"> </v-radio>
        <v-radio label="คอนกรีต" value="concrete"> </v-radio>
      </v-radio-group>

      <v-radio-group v-model="formData.crosswalkM">
      <label for=""><h2>ทางข้าม (ทางม้าลาย)</h2></label>
        <label for=""><h3>บนสายหลัก</h3></label>
        <v-radio label="มีทางข้าม" value="havecrosswalk"> </v-radio>
        <v-radio label="ไม่มีทางข้าม" value="nocrosswalk"> </v-radio>
      </v-radio-group>

      <v-radio-group v-model="formData.crosswalkS">
        <label for=""><h3>บนสายรอง</h3></label>
        <v-radio label="มีทางข้าม" value="havecrosswalk"> </v-radio>
        <v-radio label="ไม่มีทางข้าม" value="nocrosswalk"> </v-radio>
      </v-radio-group>

      <label for=""><h2>สะพานลอยคนข้าม</h2></label>
      <v-radio-group v-model="formData.overpassM">
          <label for=""><h3>บนสายหลัก</h3></label>
          <v-radio label="มีสะพานลอย" value="overpass"> </v-radio>
          <v-radio label="ไม่มีสะพานลอย" value="nooverpass"> </v-radio>
        </v-radio-group>

      <v-radio-group v-model="formData.overpassS">
        <label for=""><h3>บนสายรอง</h3></label>
          <v-radio label="มีสะพานลอย" value="overpass"> </v-radio>
          <v-radio label="ไม่มีสะพานลอย" value="nooverpass"> </v-radio>
        </v-radio-group>

      <v-radio-group v-model="formData.tunnelBridge">{{ formData.tunnelBridge }}
        <label for=""><h2>อุโมงค์หรือสะพานข้ามแยก</h2></label>
        <v-radio label="บนสายหลัก" value="main"> </v-radio>
        <v-radio label="บนสายรอง" value="secondary"> </v-radio>
      </v-radio-group>
      <v-btn type="submit" @click="onSubmit" color="info">Submit</v-btn>
      <v-card header="data">
        <!-- {{ formData }} -->
        {{ saveStatus }}
        
      </v-card>
    </v-form>
  </v-container>
</template>

<script>
import MapComponent from '~/components/MapComponent'
import SLPpart from '~/components/SLPpart'
import axios from 'axios'
import ImageUploadPreview from '~/components/ImageUploadPreview'
// import thaiSort from "thai-sort"
import thaiAlphabetSort from "thai-alphabet-sort";
import DropFile from "~/components/DropFile";



export default {
  layout: 'main_layouts',
  components: {
    SLPpart,
    MapComponent,
    ImageUploadPreview,
  },
  data() {
    return {
      items: [
        {title : "ImageUploadPreview", slug : "image-upload-preview"}
      ],
      loadData: [],
      formData: {
        highway_office: '',
        district: '',
        crossroads: '',
        junction_name: '',
        main_highway_number: '',
        main_highway_name: '',
        secondary_highway_number: '',
        secondary_highway_name: '',
        img4way: [],
        imageUrl: '',
        lightPole: null,
        lightPole_HM: '',
        lightPole_SP: '',
        lightPole_TP: '',
        lightPole_MD: '',
        lightPole_GD: '',
        lightBox: '',
        adaptive: '',
        adaptive_another: '',
        adaptive_HTOC: false,
        vehicleActuated: '',
        vehicleActuated_another: '',
        vehicleActuated_HTOC: '',
        lightBox_MD: '',
        lightBox_GD: '',
        roadType: '',
        crosswalkM: '',
        crosswalkS: '',
        overpassM: '',
        overpassS: '',
        tunnelBridge: '',
      },
      SLPlist: [{}],
      lightList: [
        {
          lightBox: 1,
          type: 'full',
          hasLightHuman: true,
          hasButton: false,
        },
      ],
      images: [],
      newImage: null,
      imgSrc: null,
      divisionLista: [],
      agencies: [],
      agenciesTH: [],
      dis_nameList: [
      ],
      unSdis_nameList: [
      ],
      divisionList: [
      ],
      saveStatus:[],

    }
  },
  // asyncData(context){
  //     return axios.get("http://127.0.0.1:5000/data")
  //     .then(res=>{
  //       const data = [];
  //       for(const key in res.data){
  //         data.push({...res.data[key],id:key});
  //       }
  //       return{
  //         loadData:data
  //       }
  //     })
  //   },

  // async fetchData() {
  //   const res = await this.$axios.$get('http://127.0.0.1:5000/data');
  //   this.divisionLista.push(res)
  // },
  // async mounted() {
  //   await this.fetchData();
  // },

  computed: {
  sortedArray: function() {
    function compare(a, b) {
      if (a.name < b.name)
        return -1;
      if (a.name > b.name)
        return 1;
      return 0;
    }

    return this.arrays.sort(compare);
  }
},


  async mounted(){
    this.getOrders()
    this.dis_nameList.sort((a, b) =>
      thai_alphabet_sort.default(a, b));
    // this.dis_nameList.sort((a, b) =>
    //   a.localeCompare(b, "th", { sensitivity: "base" }));
    if(localStorage.getItem('images')) {
      this.images = JSON.parse(localStorage.getItem('images'));
    }
  },
  methods: {
    showFilePreview(e) {
      let files = e.target.files || e.dataTransfer.files
      this.image = []
      for (let i = 0; i < files.length; i++) {
        this.image.push(files[i])
      }
      for (let i = 0; i < this.image.length; i++) {
        let reader = new FileReader()
        reader.onload = (e) => {
          this.$refs.formData.img4way[i].src = reader.result
        }
        reader.readAsDataURL(this.image[i])
      }
    },
    handleFileUpload(event) {
      this.newImage = event.target.files[0];
    },
    addImage() {
      const reader = new FileReader();
      reader.onload = () => {
        this.images.push({
          id: new Date().getTime(),
          url: reader.result
        });
        localStorage.setItem('images', JSON.stringify(this.images));
      }
      reader.readAsDataURL(this.newImage);
    },
    async getOrders(){
      // Get the default data
      await axios.get('http://127.0.0.1:5000/data').then(res => {
        this.agencies = res.data.data;
        this.agencies.forEach(agency => {
          this.divisionList.push(agency.division_name);
        });
      })

      // Get the Thai-sorted data
      await axios.get('http://127.0.0.1:5000/data', {
        params: { sort: 'thai' }
      }).then(res => {
        this.agenciesTH = res.data.dataTH;
        this.agenciesTH.forEach(agency => {
          this.dis_nameList.push(agency.dis_name);
        });
      })
    },
    async uploadImage (event) {
      const file = event.target.files[0];
      const imageUrl = URL.createObjectURL(file);
      this.formData.imageUrl = imageUrl;    
    },
    addLightList() {
      const lightData = {
        name: 'test',
      }
      this.lightList.push(lightData)
    },
    onSubmit() {
      axios.post('http://localhost:5000/save', this.formData)
        .then(response => {
          console.log(response.data)
          this.saveStatus = response.data
          return response.data
        })
        .catch(error => {
          console.log(error)
        })
    },
    openFileInput() {
      this.$refs.fileInput.click()
    },
    handleImageChange(e) {
      const reader = new FileReader()
      reader.onload = (event) => {
        this.imgSrc = event.target.result
      }
      reader.readAsDataURL(e.target.files[0])
    },
    addImage() {
      // Get the image URL
      const image = 'IMAGE_URL'

      // Add the image URL to the images array
      this.images.push(image)
    },
    removeImage(index) {
      this.images.splice(index, 1)
    },

    // dataAll() {
    //   this.getData().then((result)=>{
    //     console.log(result);
    //   })
    // },
    // getData() {
    //   return new Promise((resolve, reject) =>{
    //     setTimeout(()=>{
    //       const data = axios.get("http://127.0.0.1:5000/data").then(res =>{
    //       return res
    //       })
    //       resolve(data)
    //     }, 4000)
    //   })
    // }
  },
}
</script>

<style>
.fixed-size-img {
  width: 60px;
  height: 100px;
}

.map-size {
  width: 75%;
  height: 500px;
}
.map-margin {
  display: flex;
  align-items: center;
  justify-content: center;
  height: 100%;
  margin: 40px;
}

.center-element {
  display: flex;
  align-items: center;
  justify-content: center;
  height: 100%;
}

.v-text-field {
  display: flex;
  align-items: center;
  justify-content: center;
}

</style>
